<template>
    <a-drawer
        :title="formData.id ? '编辑异常报警' : '增加异常报警'"
        :width="600"
        :visible="visible"
        :destroy-on-close="true"
        :footer-style="{ textAlign: 'right' }"
        @close="onClose"
    >
        <a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
            <a-form-item label="企业客户：" name="depotId">
                <a-select v-model:value="formData.depotId" placeholder="请选择企业客户" :options="depotIdOptions" />
            </a-form-item>
            <a-form-item label="异常分类：" name="alarmType">
                <a-select v-model:value="formData.alarmType" placeholder="请选择异常分类" :options="alarmTypeOptions" />
            </a-form-item>
            <a-form-item label="处理状态：" name="saveState">
                <a-radio-group v-model:value="formData.saveState" placeholder="请选择处理状态" :options="saveStateOptions" />
            </a-form-item>
            <a-form-item label="异常信息：" name="alarmMsg">
                <a-input v-model:value="formData.alarmMsg" placeholder="请输入异常信息" allow-clear />
            </a-form-item>
        </a-form>
        <template #footer>
            <a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
            <a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
        </template>
    </a-drawer>
</template>

<script setup name="depotAlarmForm">
    import tool from '@/utils/tool'
    import { cloneDeep } from 'lodash-es'
    import { required } from '@/utils/formRules'
    import depotAlarmApi from '@/api/biz/depotAlarmApi'
    // 抽屉状态
    const visible = ref(false)
    const emit = defineEmits({ successful: null })
    const formRef = ref()
    // 表单数据
    const formData = ref({})
    const submitLoading = ref(false)
    const depotIdOptions = ref([])
    const alarmTypeOptions = ref([])
    const saveStateOptions = ref([])

    // 打开抽屉
    const onOpen = (record) => {
        visible.value = true
        if (record) {
            let recordData = cloneDeep(record)
            formData.value = Object.assign({}, recordData)
        }
        depotIdOptions.value = tool.dictList('depotId')
        alarmTypeOptions.value = tool.dictList('异常分类')
        saveStateOptions.value = tool.dictList('处理状态')
    }
    // 关闭抽屉
    const onClose = () => {
        formRef.value.resetFields()
        formData.value = {}
        visible.value = false
    }
    // 默认要校验的
    const formRules = {
    }
    // 验证并提交数据
    const onSubmit = () => {
        formRef.value
            .validate()
            .then(() => {
                submitLoading.value = true
                const formDataParam = cloneDeep(formData.value)
                depotAlarmApi
                    .depotAlarmSubmitForm(formDataParam, !formDataParam.id)
                    .then(() => {
                        onClose()
                        emit('successful')
                    })
                    .finally(() => {
                        submitLoading.value = false
                    })
            })
    }
    // 抛出函数
    defineExpose({
        onOpen
    })
</script>
